<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class Log_activity
{
    protected $path;
    protected $filename;
    protected $module;
    protected $function;
    protected $bank;

    public function createLog($module, $function, $message)
    {
        $this->module = $module;
        $this->function = $function;
    
        $this->path     = './logs/'.date('Y').'/'.date('m').'/'.date('d'); // Directory Logs
        $this->filename = 'log_'.$function.'_'.date('d_m_Y').'.log'; // File log
      
        $unix_micro = microtime(true);
        $timestamp_micro = date_create_from_format( 'U.u', number_format($unix_micro, 6, '.', ''))->setTimezone((new DateTimeZone('Asia/Jakarta')))->format('Y-m-d H:i:s.u');
        $list = array (
            $timestamp_micro,
            $module,
            $message
        );

        // Set permission denied di linux
        @chmod($this->path, 0777); // Folder
        @chmod($this->path.'/'.$this->filename,0777); // File

        // Set Owner
        // $user_name = 'apache';
        // @chown($this->path, $user_name);
        // @chown($this->path.'/'.$this->filename, $user_name);

        // Jika folder sudah ada maka data di update
        if ( file_exists($this->path) ) {
            // Jika file sudah ada maka data di update
            if ( file_exists($this->path.'/'.$this->filename) ) {
                // Update file csv
                $this->updateFileTxt($list);
            }
            else {
                // Create file csv
                $this->createFileTxt($list);
            }
        }
        else {
            // Create folder logs
            if ( ! mkdir($this->path, 0777, true) ) {
                echo "Gagal membuat folder";
            }
            else {
                if ( file_exists($this->filename) ) {
                    // Update file csv
                    $this->updateFileTxt($list);
                }
                else {
                    // Create file csv
                    $this->createFileTxt($list);
                }
            }
        }
    }

    /**
    * Create file TEXT
    * @param  array $list
    */
    public function createFileTxt($list)
    {
        $file = fopen($this->path.'/'.$this->filename,"w");
        $format_log = $list[0].'|'.$list[1].'|'.$list[2]."\n";
        fwrite($file, $format_log);
        fclose($file);
    }

    /**
    * Update file TEXT
    * @param  array $list
    */
    public function updateFileTxt($list)
    {
        $file = fopen($this->path.'/'.$this->filename,"a");
        $format_log = $list[0].'|'.$list[1].'|'.$list[2]."\n";
        fwrite($file, $format_log);
        fclose($file);
    }
}
