<?php

defined('BASEPATH') OR exit('No direct script access allowed');
ini_set('memory_limit', '-1');
ini_set('max_execution_time', '-1');

class Main_module extends CI_Model
{

    public function __construct()
    {
        parent::__construct();
    }

    function getListSendGps()
    {
        $this->db->select('id_do');
        $this->db->from('send_gps_x');
        $this->db->order_by('id_do desc');
        $this->db->limit('1');
        $data = $this->db->get();

        if ($data->num_rows() > 0) {
            return $data->result();
        }
        else {
            return null;
        }
    }

    function getListDO($id_do, $limit, $interval)
    {
        $this->db->select('driver_order.id, driver_order.tanggal_do_mulai,  master_bus.bus_code, master_rute.trip_id');
        $this->db->from('driver_order');
        $this->db->join('master_rute', 'driver_order.id_master_rute = master_rute.id');
        $this->db->join('master_bus', 'trim(driver_order.no_bus) = master_bus.no_bus');
        // $this->db->where('driver_order.id >'.$id_do);
        $this->db->where("driver_order.tanggal_do_mulai >= (NOW() - INTERVAL '".$interval." Minute' ) and driver_order.tanggal_do_selesai is null and driver_order.bko_id_master_rute = 0 and driver_order.id_master_kategori_driver_order = 1 and master_bus.bus_code is not null");
        $this->db->limit($limit);
        $this->db->order_by('driver_order.id desc');
        $data = $this->db->get();

        if ($data->num_rows() > 0) {
            return $data->result();
        }
        else {
            return null;
        }
    }

    function getListDO_BKO($id_do, $limit, $interval)
    {
        $this->db->select('driver_order.id, driver_order.tanggal_do_mulai,  master_bus.bus_code, master_rute.trip_id');
        $this->db->from('driver_order');
        $this->db->join('master_rute', 'driver_order.bko_id_master_rute = master_rute.id');
        $this->db->join('master_bus', 'trim(driver_order.no_bus) = master_bus.bus_code');
        // $this->db->where('driver_order.id >'.$id_do);
        $this->db->where("driver_order.tanggal_do_mulai >= (NOW() - INTERVAL '".$interval." Minute' ) and driver_order.tanggal_do_selesai is null and id_master_kategori_driver_order = 3 and bko_id_master_rute != 0 and master_bus.bus_code is not null");
        $this->db->limit($limit);
        $this->db->order_by('driver_order.id desc');
        $data = $this->db->get();

        if ($data->num_rows() > 0) {
            return $data->result();
        }
        else {
            return null;
        }
    }


    function getListDOSample()
    {
        $this->db->select('driver_order.id, master_bus.bus_code, master_rute.trip_id');
        $this->db->from('driver_order');
        $this->db->join('master_rute', 'driver_order.id_master_rute = master_rute.id');
        $this->db->join('master_bus', 'driver_order.no_bus = master_bus.no_bus');
        // $this->db->where('driver_order.id >'.$id_do);
        // $this->db->where("driver_order.tanggal_do_mulai >= (NOW() - INTERVAL '5 Minute' ) and driver_order.tanggal_do_selesai is null");
        $this->db->where('driver_order.no_bus', 'KAJ289');
        $this->db->limit(1);
        // $this->db->limit('1');
        $data = $this->db->get();

        if ($data->num_rows() > 0) {
            return $data->result();
            
        }
        else {
            return null;
        }
    }

    function updateCurrentTripGPS($bus_code, $trip_id)
    {
        $db_gps = $this->load->database('gps', TRUE);
        $db_gps->trans_begin();

        $value = "inner join bus b on cp.device_id=b.device_id and replace(b.bus_code,' ','')=replace('".$bus_code."',' ','') set koridor=(select distinct koridor from tripdata where trip_id='".$trip_id."'), current_tripid='".$trip_id."'";
        $db_gps->query('update current_pos cp '.$value);
        
        if ($db_gps->trans_status() === FALSE) {
            $db_gps->trans_rollback();
            return false;
        }
        else {
            $db_gps->trans_commit();
            return true;
        }
    }

    function insertSendGps($data)
    {
        $this->db->trans_begin();

        $this->db->insert('send_gps_x', $data);
        
        if ($this->db->trans_status() === FALSE) {
            $this->db->trans_rollback();
            return false;
        }
        else {
            $this->db->trans_commit();
            return true;
        }
    }

    function getListCurentPost()
    {
        $db_gps = $this->load->database('gps', TRUE);

        $db_gps->select('id');
        $db_gps->from('current_pos');
        $db_gps->order_by('id desc');
        $db_gps->limit('1');
        $data = $db_gps->get();

        if ($data->num_rows() > 0) {
            return $data->result();
        }
        else {
            return null;
        }
    }

}
